//=============================================================================
// UT99 Extension Pack V1.0
// - Basic Edition -
// class by Shadow
// EnvironmentEmitter, base class of all particle emitter placed in maps
// some cannot be spawned !
//=============================================================================
class EnvironmentEmitter expands ParticleEmitter;

var(Misc) bool bModulateGlowTex;
var(Misc) bool bGlowTexture,bGlowTexHasRelativeSize,bGlowTexHasRelativeScaleglow,bSetGlowTexPrepivot;
var(Misc) texture GlowTex;
var(Misc) vector GlowTexPrepivot;
var(Misc) float GlowTextureScaleglow,GlowTexturesize;
var(Performance) bool bNearCheck;
var(Performance) int NearDetailDropRadius;
var(Animation) float animSpeed;
var(Animation) int numFrames,nextFrame;
var(Animation) texture Pclframes[32];
var(Animation) bool bAnimateParticles;
var float time, totalTime, duration;

simulated function Tick(float deltaTime)
{
	if (bAnimateParticles)
	{
		time += deltaTime;
		totalTime += deltaTime;
		if (time >= animSpeed)
		{
			particlesprite = pclframes[nextFrame++];
			time -= animSpeed;
		}
	}
	super.tick(deltatime);
	if(bNearCheck&&class'xtmutator'.default.bemitternear)
	{
		if(class'XTPhysicUtil'.static.IsActorInRadius(derandy.location,location,false,NearDetailDropRadius))
		{
			if(glowtex!=none)bglowtexture=false;
		}
		else if(glowtex!=none)bglowtexture=true;
	}
}
function getparticleoptions()
{
	super.getparticleoptions();
	if (bGlowTexture&&class'xtmutator'.default.particledetail>=4&&class'xtmutator'.default.bemitterglow)
	{
		p.brelativesize=bGlowTexHasRelativeSize;
		p.brelxtratex2=bGlowTexHasRelativeScaleglow;
		p.gdraw = GlowTextureSize;
		p.gscale = GlowTextureScaleglow;
		if (bsetglowtexprepivot)
		{
			p.glowpre=glowtexprepivot;
			p.bsetprepivot=true;
		}
		p.gtex2=glowtex;
		p.bglowtex=true;
		p.balphablend=bmodulateglowtex;
		p.GlowAttacher();
	}
}

defaultproperties
{
     GlowTextureScaleglow=1.000000
     GlowTexturesize=0.500000
     NearDetailDropRadius=112
     Radius=(nradius=0,X=0,Y=0,Z=0)
     TurnOffRadius=0.000000
     bSetDetailByMenu=False
     AllowedFOV=0
     bNoDelete=True
}
