//=============================================================================
// UT99 Extension Pack V1.0
// - Basic Edition -
// class by Shadow
// MiscEmitter, base emitter class for all additional and more special emitter
// classes
//=============================================================================
class MiscEmitter expands ParticleEmitter;

var(Performance) bool bNearCheck;
var(Light) byte PclLightBrightness,PclLightRadius,PclLightHue,PclLightSaturation;
var(Light) bool bUseLightEffects;
var(Anim) texture AnimFrames[32];
var(Anim) float AnimSpeed;
var(Anim) bool bAnimate,bRepeatAnim;
var(Anim) int Numframes;
var(Misc) bool bModulateBlendGlowTex;
var(Misc) bool bGlowTexture,bGlowTexHasRelativeSize,bGlowTexHasRelativeScaleglow,bSetGlowTexPrepivot;
var(Misc) texture GlowTex;
var(Misc) vector GlowTexPrepivot;
var(Misc) float GlowTextureScaleglow,GlowTexturesize;
var(Physics) bool bEnableAmplitudeMovement;
var(Physics) int AmpXSpeed,AmpYSpeed,AmpZSpeed,AmpXAmplitude,AmpYAmplitude,AmpZAmplitude;
var(Physics) float AmpFClampCombiner,AmpFClampCombiner2,AmpSmerpCombiner,AmpSmerpCombiner2,AmpLerpCombiner,AmpLerpCombiner2;
var(Physics) enum EAmplitudeMovementMode
{
	Amp_SinusAmplitude,
	Amp_LogeAmplitude,
	Amp_SquareAmplitude,
	Amp_SqrtAmplitude,
	Amp_ExpolateAmplitude,
	Amp_TangensAmplitude,
	Amp_ATangensAmplitude,
	Amp_CosineAmplitude,
	Amp_AbsAmplitude,
	Amp_SmerpAmplitude,
	Amp_LerpAmplitude,
	Amp_FClampAmplitude
}AmplitudeMovementMode;

var(Physics) enum EAmplitudeUsedAxe
{
	Axe_X,
	Axe_Y,
	Axe_Z,
	Axe_XZ,
	Axe_YZ,
	Axe_XYZ
}AmplitudeUsedAxe;

function AmplitudeMover()
{
	if (!benableamplitudemovement)
	{
		p.xspeed=0;
		p.Yspeed=0;
		p.zspeed=0;
		p.xamplitude=0;
		p.yamplitude=0;
		p.zamplitude=0;
		ampxamplitude=0;
		ampyamplitude=0;
		ampyamplitude=0;
		ampxspeed=0;
		ampyspeed=0;
		ampzspeed=0;
		p.buseamplitude=false;
	}
	else
	{
		p.xspeed=ampxspeed;
		p.yspeed=ampyspeed;
		p.zspeed=ampzspeed;
		p.xamplitude=ampxamplitude;
		p.yamplitude=ampyamplitude;
		p.zamplitude=ampzamplitude;
		p.buseamplitude=true;
	}
	if (amplitudeusedaxe==axe_x)p.amplicoordinate=0;
	else if (amplitudeusedaxe==axe_y)p.amplicoordinate=1;
	else if (amplitudeusedaxe==axe_z)p.amplicoordinate=2;
	else if (amplitudeusedaxe==axe_xz)p.amplicoordinate=3;
	else if (amplitudeusedaxe==axe_yz)p.amplicoordinate=4;
	else p.amplicoordinate=5;
	if (amplitudemovementmode==amp_sinusamplitude)p.amplitudeangle=ang_sin;
	else if (amplitudemovementmode==amp_logeamplitude)p.amplitudeangle=ang_loge;
	else if (amplitudemovementmode==amp_cosineamplitude)p.amplitudeangle=ang_cos;
	else if (amplitudemovementmode==amp_expolateamplitude)p.amplitudeangle=ang_exp;
	else if (amplitudemovementmode==amp_tangensamplitude)p.amplitudeangle=ang_tan;
	else if (amplitudemovementmode==amp_atangensamplitude)p.amplitudeangle=ang_atan;
	else if (amplitudemovementmode==amp_squareamplitude)p.amplitudeangle=ang_square;
	else if (amplitudemovementmode==amp_absamplitude)p.amplitudeangle=ang_abs;
	else if (amplitudemovementmode==amp_sqrtamplitude)p.amplitudeangle=ang_sqrt;
	else if (amplitudemovementmode==amp_smerpamplitude)
	{
		p.samp=ampsmerpcombiner;
		p.samp2=ampsmerpcombiner2;
		p.amplitudeangle=ang_smerp;
	}
	else if (amplitudemovementmode==amp_lerpamplitude)
	{
		p.lamp=amplerpcombiner;
		p.lamp2=amplerpcombiner2;
		p.amplitudeangle=ang_lerp;
	}
	else
	{
		p.famp=ampfclampcombiner;
		p.famp2=ampfclampcombiner2;
		p.amplitudeangle=ang_fclamp;
	}
}
function anim()
{
	local int i;
	for (i=0;i<NumFrames;i++)
	{
		if(animframes[i]!=none)p.frames[i]=AnimFrames[i];
	}
	p.numframes=numframes;
	p.animspeed=animspeed;
	p.brepeat=bRepeatAnim;
	p.banim=true;
}
function LightStuff()
{
	if (bUseLightEffects&&class'xtmutator'.default.particledetail>=2)
	{
		p.lightradius=pcllightradius;
		p.lightbrightness=pcllightbrightness;
		p.lighthue=pcllighthue;
		p.lightsaturation=pcllightsaturation;
		p.lighteffect=lighteffect;
		p.lighttype=lighttype;
	}
}
simulated function Tick(float deltatime)
{
	super.tick(deltatime);
	if(bNearCheck)
	{
		if(class'XTPhysicUtil'.static.IsActorInRadius(derandy.location,location,false,80))if(bglowtexture)bglowtexture=false;
		else if(bglowtexture)bglowtexture=true;
	}

}
function getparticleoptions()
{
	super.getparticleoptions();
	if (bGlowTexture&&class'XTMutator'.default.particledetail>=2)
	{
		p.brelativesize=bGlowTexHasRelativeSize;
		p.brelxtratex2=bGlowTexHasRelativeScaleglow;
		p.gdraw = GlowTextureSize;
		p.gscale = GlowTextureScaleglow;
		if (bsetglowtexprepivot)
		{
			p.glowpre=glowtexprepivot;
			p.bsetprepivot=true;
		}
		p.gtex2=glowtex;
		p.bglowtex=true;
		p.balphablend=bmodulateblendglowtex;
		p.GlowAttacher();
	}
	amplitudeMover();
	LightStuff();
	if(banimate)anim();
}

defaultproperties
{
     PclLightBrightness=64
     PclLightRadius=4
     Radius=(nradius=0,X=0,Y=0,Z=0)
     TurnOffRadius=0.000000
     AllowedFOV=0
}
